/*
 * CImagenexSidescanSonarDataManip.h
 *
 *  Created on: Mar 9, 2011
 *      Author: Joel Vidal
 */

#ifndef CIMAGENEXSIDESCANSONARDATAMANIP_H_
#define CIMAGENEXSIDESCANSONARDATAMANIP_H_

#include "../CDataManip.h"

struct SImagenexSidescanSonarData {
	int serialStatus ;
	int range ;
	int frequency ;
	int gain ;
	Eigen::VectorXd portChannel ;
	Eigen::VectorXd starboardChannel ;
} ;

class CImagenexSidescanSonarDataManip : public CDataManip<  SImagenexSidescanSonarData > {
public:

	CImagenexSidescanSonarDataManip():
		CDataManip<  SImagenexSidescanSonarData >( "imagenex_sidescan_sonar_data" )
	{
		addItem( "serial_status", & SImagenexSidescanSonarData::serialStatus ) ;
		addItem( "range", & SImagenexSidescanSonarData::range ) ;
		addItem( "frequency", & SImagenexSidescanSonarData::frequency ) ;
		addItem( "gain", & SImagenexSidescanSonarData::gain ) ;
		addItem( "port_channel", &SImagenexSidescanSonarData::portChannel ) ;
		addItem( "starboard_channel", &SImagenexSidescanSonarData::starboardChannel ) ;
	}

	std::string
	getLogHeader() const
	{
		//return stringifyNames() ;
		return  "serial_status\t"
				"range(m)\t"
				"frequency\t"
				"gain(dB)\t"
				"port_channel\t"
				"starboard_channel\t"
				;
	}



	std::string
	getLogEntry() const
	{
		std::ostringstream logEntry ;
		logEntry << getData().serialStatus << "\t"
				 << getData().range << "\t"
				 << getData().frequency << "\t"
				 << getData().gain << "\t"
				 << getData().portChannel.transpose() << "\t"
				 << getData().starboardChannel.transpose()
				 ;
		return logEntry.str() ;
	}

} ;

#endif /* CIMAGENEXSIDESCANSONARDATAMANIP_H_ */
