/*
 * CEthernetTest.cpp
 *
 *  Created on: Feb 4, 2011
 *      Author: Joel Vidal
 */

#include "CEthernetTest.h"



void
CEthernetTest::connect( const std::string& IP,
						const std::string& port )
{
	boost::asio::ip::tcp::resolver resolver( io_service_ );
	boost::asio::ip::tcp::resolver::query query( IP, port );
	boost::asio::ip::tcp::resolver::iterator endpoint_iterator = resolver.resolve( query );
	boost::asio::ip::tcp::resolver::iterator end; // End marker.n.

	boost::system::error_code error = boost::asio::error::host_not_found;

	while ( error && endpoint_iterator != end ) {
		 socket_.close();
		 socket_.connect( *endpoint_iterator++ , error );
	}

	if ( error )
		 throw boost::system::system_error( error );

}



void
CEthernetTest::connect( const std::string& IP,
						const int port )
{
	std::string sPort;
	char cPort[6];
	sprintf( cPort, "%i", port );
	sPort.assign( cPort );
	connect( IP, sPort );
}



void
CEthernetTest::send( const std::string& dataString )
{
	boost::system::error_code ec;
	socket_.send( boost::asio::buffer( dataString ), 0, ec );

	if ( ec )
		throw boost::system::system_error( ec );
}



void
CEthernetTest::send( const char* data,
					 int nBytes )
{
	boost::system::error_code ec;
	socket_.send( boost::asio::buffer( data, nBytes ), 0, ec );

	if ( ec )
		throw boost::system::system_error( ec );

}



void
CEthernetTest::receive( std::string& dataString,
						int& nBytes )
{
	char receiveBuffer[1400];
	boost::system::error_code ec;
	nBytes=socket_.receive( boost::asio::buffer( receiveBuffer ), 0, ec );

	if ( ec )
		throw boost::system::system_error( ec );

	dataString.assign( receiveBuffer, nBytes );
}



void
CEthernetTest::receive( char* data,
						int& nBytes )
{
	boost::system::error_code ec;
	nBytes=socket_.receive( boost::asio::buffer( data, nBytes ), 0, ec );

	if ( ec )
		throw boost::system::system_error( ec );
}



void
CEthernetTest::close()
{
	boost::system::error_code ec;

	socket_.close();

	if (ec)
		throw boost::system::system_error(ec);
}



CEthernetTest::CEthernetTest()
:
	socket_(io_service_)
{

}



CEthernetTest::~CEthernetTest() {
	// TODO Auto-generated destructor stub
}
