/*
 * CEthernetTest.h
 *
 *  Created on: Feb 4, 2011
 *      Author: Joel Vidal
 */

#include <string>
#include <ostream>
#include <boost/asio.hpp>
#include <boost/thread.hpp>
using namespace std;

#ifndef CETHERNETTEST_H_
#define CETHERNETTEST_H_

class CEthernetTest {
	public:

	/*
	 * Connectar a una adreça.
	 */
	void
	connect( const std::string& IP,
			 const std::string& port );

	/*
	 * Connectar a una adreça.
	 */
	void
	connect( const std::string& IP,
			 const int port );

	/*
	 * Enviar dades
	 */
	void
	send( const std::string& dataString );

	/*
	 * Enviar dades (char)
	 */
	void
	send( const char* data,
		  int nBytes );

	/*
	 * Llegir dades
	 */
	void
	receive( std::string& dataString,
			 int& nBytes );

	/*
	 * Llegir dades
	 */
	void
	receive( char* data,
			 int& nBytes );

	/*
	 * Tancar conexió
	 */
	void
	close();

	CEthernetTest();

	virtual ~CEthernetTest();



	private:

	boost::asio::io_service io_service_;
	boost::asio::ip::tcp::socket socket_;

};

#endif /* CETHERNETTEST_H_ */
