%Netejem les variables
clear;

%Busquem un fitxer
[filename, pathname] = uigetfile('*.log');
log = strcat(pathname,filename);

%Carreguem el log
[dades,nF,nC] = openLog( log );

%Comprovem que l'arxiu sigui correcte
if (nF < 10 || nC ~= 2011) 
    error('Arxiu incorrecte');
end

%Mostrem en nom del fitxer selleccionat
fprintf('\nNOM DEL FITXER:\n');
disp(log);

%Inicialitzem les variables
nLines = 400; %numero de lines de la imatge
circularBufferPos = 1;
circularBuffer = zeros(nLines,2000);
image = zeros(nLines,2000);
varTime2 = 0 ;

%Mostrem els parametres de la captura
fprintf('\nDADES DE LA CAPTURA:');
fprintf('\nRang: %d m', dades(2,9));

if (dades(2,10) == 0)
    freq = 260;
elseif (dades(2,10) == 1)
    freq = 330;
else
    freq = 770;
end

fprintf('\nFreqencia: %d kHz', freq);
fprintf('\nGuany: %d dB\n\n', dades(2,11));

%Establim la figure
figure(1);
set(1,'Name', 'SSSLogsView')

%Per cada linia
for pos=1:nF
    
    %Obtenim el temps de captura del ping
    imageDate = dades(pos:pos,1:7);
    
    %Obtenim les dades de babord i estribord
    line = dades(pos:pos,12:nC);
     
    %Afegim la imatge lineal al buffer ciclic
    circularBuffer(circularBufferPos,1:1000) = line(1000:-1:1); %Babord
    circularBuffer(circularBufferPos,1001:2000) = line(1001:2000); %Estribord
    
    %Copiem Buffer Ciclic a el buffer image
    if (circularBufferPos < nLines)
        image(1:nLines-circularBufferPos,:) = circularBuffer(circularBufferPos+1:nLines,:);  
    end
    image((nLines-circularBufferPos)+1:nLines,:) = circularBuffer(1:circularBufferPos,:);
    
    
    circularBufferPos = circularBufferPos + 1;
    
    %Control Buffer Ciclic
    if (circularBufferPos > nLines)
        circularBufferPos = 1;
    end
    
    %Pintem la imatge per pantalla
    colormap( gray ) ;
    imagesc( image ) ;
    
    %Calculem temps del proxim ping
    varTime1 = imageDate( 7 ) ;
    ping = mod(varTime1 - varTime2, 1000) ;
    varTime2 = varTime1 ;
    
    pause( ping / 1000 );
end
